/// <reference types="node" />
import { EventEmitter } from "events";
export interface LoggingBaseOptions {
    logfile: string;
    errorfile: string;
    console_out: boolean;
}
export declare class LoggingBase {
    private config;
    private writeLock;
    private fileStream;
    private errorStream;
    private fileSize;
    private errorSize;
    private queue;
    constructor(options?: Partial<LoggingBaseOptions>);
    console_out: boolean;
    waitForSetup(): Promise<void>;
    private setup();
    events: EventEmitter;
    debug(...message: any[]): void;
    log(...message: any[]): void;
    warning(...message: any[]): void;
    logWithCustomColors(type: LoggingTypes, colors: string, ...message: any[]): void;
    error(error: Error | string): void;
    errorMessage(...message: any[]): void;
    private message(type, message, customColors?);
    private writeMessageToFile(message, error?);
    private checkQueue();
    private writeToLogFile(data);
    private writeToErrorFile(data);
    private initializeFile(file, new_file?);
}
export declare const Logging: LoggingBase;
export default Logging;
export declare enum LoggingTypes {
    Log = 0,
    Warning = 1,
    Error = 2,
    Debug = 3,
}
